/**


	Ksztette: Varga Lszl

 */

#include <stdlib.h>
#include <GL/glut.h>
#include <time.h>
#include <stdio.h>

#ifndef __BITMAPANIM_H___
#define __BITMAPANIM_H___

#  ifdef __cplusplus
extern "C" {
#  endif /* __cplusplus */


struct BitmapAnim {
	unsigned char* pixels;
	int x, y;
	unsigned int startTime;
	void* extraData;

	void (*genFrame)(BitmapAnim*, int);

	BitmapAnim(int width, int height) {
		pixels = new unsigned char[width * height * 4];
		x = width;
		y = height;
	}

	~BitmapAnim() {
		delete[] pixels;
	}

	unsigned char* get_ptr(void) const {
		return pixels;
	}

	long image_size( void ) const {
		return x * y * 4;
	}

	static BitmapAnim** getBitmapPtr( void ){
		static BitmapAnim* ptr;
		return &ptr;
	}

	static void Key(unsigned char key, int x, int y) {
		switch(key) {
			case 27:
				exit(0);
		}

	}

	static void Draw() {
		BitmapAnim* bitmapPtr = *(getBitmapPtr());

		glClearColor(0.0, 0.0, 0.0, 1.0);
		glClear(GL_COLOR_BUFFER_BIT);
		glDrawPixels(bitmapPtr->x, bitmapPtr->y, GL_RGBA, GL_UNSIGNED_BYTE, bitmapPtr->pixels);

		glFlush();
		glutSwapBuffers();
	}

	static void idleFunct( void ) {
		BitmapAnim* bitmapPtr = *(getBitmapPtr());
		
		printf("%i\n", clock() - bitmapPtr->startTime);
		bitmapPtr->genFrame(bitmapPtr, clock() - bitmapPtr->startTime );

		glutPostRedisplay();

		return;
	}

	void startAnim() {
		BitmapAnim** bitmapPtr = getBitmapPtr();
		*bitmapPtr = this;

		int c = 1;
		char* str = "";

		startTime = clock();
		
		glutInit(&c, &str);
		glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA);
		glutInitWindowSize( x, y );
		glutCreateWindow("bitmap image");
		glutKeyboardFunc(Key);
		glutDisplayFunc(Draw);
		glutIdleFunc(idleFunct);
		glutMainLoop();

		return;
	}

};


#  ifdef __cplusplus
}
#  endif /* __cplusplus */


#endif /* __BITMAPSTRUCT_H___ */
