#include "BitmapAnim.h"
#include <stdio.h>

void genFrame(BitmapAnim* animObj, int time) {
	int i, j;

	for(i=0; i<animObj->y; i++) {
		for(j=0; j<animObj->x; j++) {
			animObj->pixels[(i*animObj->x + j)*4 + 0] = time/100 + i;
			animObj->pixels[(i*animObj->x + j)*4 + 1] = time/100 + j;
			animObj->pixels[(i*animObj->x + j)*4 + 2] = 255;
			animObj->pixels[(i*animObj->x + j)*4 + 3] = 255;
		}
	}

	return;
}

int main(int argc, char** argv) {

	BitmapAnim animObj(256, 256);
	animObj.genFrame = genFrame;

	animObj.startAnim();

	return 0;
}
